--- old/usr/src/uts/common/inet/snmpcom.c	2015-12-04 14:19:24.975591329 +0300
+++ new/usr/src/uts/common/inet/snmpcom.c	2015-12-04 14:19:24.984338496 +0300
@@ -107,6 +107,17 @@
 	return (1);
 }
 
+int
+snmp_append_mblk(mblk_t *mpdata, mblk_t *mblk)
+{
+	if (!mpdata || !mblk)
+		return (0);
+	while (mpdata->b_cont)
+		mpdata = mpdata->b_cont;
+	mpdata->b_cont = mblk;
+	return (1);
+}
+
 /*
  * Need a form which avoids O(n^2) behavior locating the end of the
  * chain every time.  This is it.
@@ -133,6 +144,21 @@
 	return (1);
 }
 
+int
+snmp_append_mblk2(mblk_t *mpdata, mblk_t **last_mpp, mblk_t *mblk)
+{
+	if (!mpdata || !mblk)
+		return (0);
+	if (*last_mpp == NULL) {
+		while (mpdata->b_cont)
+			mpdata = mpdata->b_cont;
+		*last_mpp = mpdata;
+	}
+	(*last_mpp)->b_cont = mblk;
+	*last_mpp = (*last_mpp)->b_cont;
+	return (1);
+}
+
 /*
  * SNMP requests are issued using putmsg() on a stream containing all
  * relevant modules.  The ctl part contains a O_T_OPTMGMT_REQ message,
